use 5.000005;
use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
my $P = '../../src';
WriteMakefile(
    MAKEFILE          => 'Makefile.perl',
    NAME              => 'ToyChemistry',
    VERSION_FROM      => 'lib/ToyChemistry.pm', # finds $VERSION
    PREREQ_PM         => {}, # e.g., Module::Name => 1.1
    ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
      (ABSTRACT_FROM  => 'lib/ToyChemistry.pm', # retrieve abstract from module
       AUTHOR         => 'Christoph Flamm <xtof@tbi.univie.ac.at>') : ()),
    LIBS              => ['-lstdc++'], # e.g., '-lm'
    MYEXTLIB          => "$P/toychemlib/libtoychem.a $P/graphlib/libgraphlib.a",
    DEFINE            => '', # e.g., '-DHAVE_SOMETHING'
    INC               => "-I. -I$P/toychemlib -I$P/graphlib",
    XSOPT             => '-C++',
    CC                => 'g++',
    OBJECT            => '$(O_FILES)', # link all the C files too
);
if  (eval {require ExtUtils::Constant; 1}) {
  # If you edit these definitions to change the constants used by this module,
  # you will need to use the generated const-c.inc and const-xs.inc
  # files to replace their "fallback" counterparts before distributing your
  # changes.
  my @names = (qw());
  ExtUtils::Constant::WriteConstants(
                                     NAME         => 'ToyChemistry',
                                     NAMES        => \@names,
                                     DEFAULT_TYPE => 'IV',
                                     C_FILE       => 'const-c.inc',
                                     XS_FILE      => 'const-xs.inc',
                                  );

}
else {
  use File::Copy;
  use File::Spec;
  foreach my $file ('const-c.inc', 'const-xs.inc') {
    my $fallback = File::Spec->catfile('fallback', $file);
    copy ($fallback, $file) or die "Can't copy $fallback to $file: $!";
  }
}
