#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "const-c.inc"

#include "toychemistry.hpp"

MODULE = ToyChemistry		PACKAGE = ToyChemistry		

INCLUDE: const-xs.inc

void
Energy(params, smiles)
  SV * params;
  SV * smiles;
PROTOTYPE: $$
PREINIT:
  char * paramFile;
  char * smiString;
  double energy;
PPCODE:
  paramFile = SvPV(params, SvCUR(params));
  smiString = SvPV(smiles, SvCUR(smiles));
  energy = ToyChem_energy(smiString, paramFile);
  XPUSHs(sv_2mortal(newSVnv(energy)));

void
DipoleMomentum(params, smiles)
  SV * params;
  SV * smiles;
PROTOTYPE: $$
PREINIT:
  char *paramFile;
  char *smiString;
  double dpm;
PPCODE:
  paramFile = SvPV(params, SvCUR(params));
  smiString = SvPV(smiles, SvCUR(smiles));
  dpm = ToyChem_dipole_momentum(smiString, paramFile);
  XPUSHs(sv_2mortal(newSVnv(dpm)));

void
SolvationEnergy(params, smiles, solven)
  SV * params;
  SV * smiles;
  SV * solven;
PROTOTYPE: $$$
PREINIT:
  char * paramFile;
  char * smiString;
  double solv;
  double dpm;
PPCODE:
  paramFile = SvPV(params, SvCUR(params));
  smiString = SvPV(smiles, SvCUR(smiles));
  solv = SvNV(solven);
  dpm = ToyChem_solvation_energy(smiString, paramFile, solv);
  XPUSHs(sv_2mortal(newSVnv(dpm)));

void
Charges(params, smiles)
  SV * params;
  SV * smiles;
PROTOTYPE: $$
PREINIT:
  char * paramFile;
  char * smiString;
  char * charges;
  SV * blub;
PPCODE:
  paramFile = SvPV(params, SvCUR(params));
  smiString = SvPV(smiles, SvCUR(smiles));
  charges = ToyChem_charges(smiString, paramFile);
  blub = newSVpv(charges, 0);
  sv_setpv(blub, charges);
  Safefree(charges);
  XPUSHs(sv_2mortal(blub));
