/*
  Last changed Time-stamp: <2005-01-04 01:43:14 xtof>
  $Id: toychemistry.cpp,v 1.1.1.1 2005/01/04 15:52:03 xtof Exp $
*/
#include <cstdlib>
#include <string>
#include <sstream>

#include "smi2gml.h"
#include "graph.h"
#include "eht.h"

// logging exceptions and tracing
graphlib::Trace trace;
// logging debug messages
//graphlib::LogFile logfile;

/**/
double
ToyChem_energy(char *smile, char *params)
{
  //INIT_TRACE("trace.graphlibtest");
  //INIT_LOGFILE("log.graphlibtest");
  
  Smi2Gml s;
  graphlib::Graph mol;

  s.init_smi(smile);
  s.smi2gml(mol);

  Eht X(mol, params, 0);
  return (X.energy-X.rep);
}

/**/
double
ToyChem_dipole_momentum(char *smile, char *params)
{
  Smi2Gml s;
  graphlib::Graph mol;

  s.init_smi(smile);
  s.smi2gml(mol);

  Eht X(mol, params, 0);
  return (X.printDipoleMmt());
}

/**/
double
ToyChem_solvation_energy(char *smile, char *params, double solv)
{
  Smi2Gml s;
  graphlib::Graph mol;

  s.init_smi(smile);
  s.smi2gml(mol);

  Eht X(mol, params, 0);
  return (X.printSolvE(solv));
}

/**/
const char *
ToyChem_charges(char *smile, char *params)
{
  std::ostringstream outStr;
  string output;
  Smi2Gml s;
  graphlib::Graph mol;

  s.init_smi(smile);
  s.smi2gml(mol);

  Eht X(mol, params, 0);
  outStr << X.printCharges();
  output = outStr.str();
  return (output.c_str());
}

// End of file
