/***************************************************************************
                          bicompdata.cpp  -  description
                             -------------------
    begin                : Sun Mar 11 2001
    copyright            : (C) 2001 by Gleiss Petra Manuela
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bicompdata.h"

namespace graphlib {

//---------------------------------------------------------------------------
// Con-/Destructors
//---------------------------------------------------------------------------
BiCompData::BiCompData()
{
  dnf = low = 0; marked = false;
}

//---------------------------------------------------------------------------
// Operators
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Set Functions
//---------------------------------------------------------------------------
BiCompData& BiCompData::setBiCompData(bool m, unsigned d, unsigned l)
{
  dnf    = d;
  low    = l;
  marked = m;
  return *this;
}
BiCompData& BiCompData::setBiCompData(bool m, unsigned d, unsigned l,
                                      const Node& f)
{
  dnf    = d;
  low    = l;
  marked = m;
  father = f;
  return *this;
}
BiCompData& BiCompData::changeLow(unsigned l)
{
  low = l;
  return *this;
}
//---------------------------------------------------------------------------
// Input / Output
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, const BiCompData& bCD)
{
  os << "\tdnf: " << bCD.dnf << "\tlow " << bCD.low
     << "\tmarked: " << bCD.marked << "\tfather: ";

  if (bCD.father.isNULL())
    os << "NULL";
  else
    os << bCD.father.id();
  return os;
}


} // namespace graphlib

/* end of file */
