/***************************************************************************
                          coordinates.cpp  -  description
                             -------------------
    begin                : Wed Mar 7 2001
    copyright            : (C) 2001 by Gleiss Petra Manuela
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "coordinates.h"

#include <stdexcept>

namespace graphlib {

//---------------------------------------------------------------------------
// Con-/Destructors
//---------------------------------------------------------------------------
Coordinates::Coordinates(double a, double b, double c)
      : x(a), y(b), z(c)
{
  ;
}

//---------------------------------------------------------------------------
// Operators
//---------------------------------------------------------------------------
Coordinates& Coordinates::operator=(const Coordinates& c)
{
  x=c.x; y=c.y; z=c.z;
  return *this;
}

//---------------------------------------------------------------------------
// Input / Output
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, const Coordinates& c)
{
  os.precision(4);
  os.setf(ios::fixed,ios::floatfield);
  return os << "\n      x " << c.x << "\n      y " << c.y
            << "\n      z " << c.z;
}

} // namespace graphlib

/* end of file */
