/***************************************************************************
                          edgeid.h  -  description
                             -------------------
    begin                : Mon Mar 5 2001
    copyright            : (C) 2001 by Gleiss Petra Manuela
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EDGEID_H
#define EDGEID_H

#include "edge.h"
#include "node.h"
#include <functional>


namespace graphlib {

/**
  *@internal
  *
  */

class EdgeId : public unary_function<Edge,bool>
{
  public:
    explicit EdgeId(unsigned i) : id(i) {}
    bool operator()(const Edge& e) const
    {
      return (e.id() == id);
    }
  private:
    unsigned id;
}; // class EdgeId

/**
  *@internal
  *
  */

class EdgeSourceTarget : public unary_function<Edge,bool>
{
  public:
    explicit EdgeSourceTarget(unsigned s, unsigned t) : source(s),target(t) {}
    bool operator()(const Edge& e) const
    {
      return ((e.source().id() == source && e.target().id() == target) ||
              (e.source().id() == target && e.target().id() == source) );
    }
  private:
    unsigned source,target;
}; // class EdgeSourceTarget

} // namespace graphlib
#endif  // EDGEID_H

/* end of file */
