/***************************************************************************
                          gml_error.h  -  description
                             -------------------
    begin                : Mon Apr 2 2001
    copyright            : (C) 2001 by Gleiss Petra Manuela
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GML_ERROR_H
#define GML_ERROR_H

#include <stdexcept>
#include <string>

namespace graphlib {

/**
  *@author Gleiss Petra Manuela
  */

class GML_Error : public runtime_error
{
	protected:
  	//------------------------------------------------------ Con-/Destructor
    GML_Error():runtime_error("") {;}
  public:
  	//------------------------------------------------------ Con-/Destructor
	  GML_Error(const string& what_arg) : runtime_error(what_arg),_what("GML Error:"+what_arg) {;}

	~GML_Error() throw();
	
  	//------------------------------------------------------ Infomation
	  virtual const char* what() const throw() {return _what.c_str();}
	
	private:
  	//------------------------------------------------------ Datas
  	string _what;
}; // class GML_Error

} // namespace graphlib

#endif //GML_ERROR_H

/* end of file */


