/***************************************************************************
                          nodepath.h  -  description
                             -------------------
    begin                : Thu Mar 1 2001
    copyright            : (C) 2001 by Gleiss Petra Manuela
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODEPATH_H
#define NODEPATH_H

#include "node.h"
#include "graphlib.h"

#include <list>

namespace graphlib {

/**
  *@internal
  */

class NodePath
{
  public:
  	//------------------------------------------------------ Constructor
    NodePath() : marked(false),distance(UINT_MAX),path(list<Node>()) { ; }

    NodePath(const Node& n) : marked(false),distance(UINT_MAX),
                              path(list<Node>(1,n)) { ; }

  	//------------------------------------------------------ Calculations
  	/**
  	  * Returns true if the intersection <code>this->path</code> and
  	  * <code>np->path</code> equals <code>node</code> else false.
  	  *
  	  * @param second path
  	  * @param node
  	  */
  	bool intersectionPath(const NodePath& np, const Node& node) const;
  	
  	//------------------------------------------------------ Datas
    bool           marked;    //
    unsigned       distance;  // shortest distance to the first node in the path
    list<Node>     path;      // shortest path to the first node

}; // class NodePath

#endif  // NODEPATH_H

} // namespace graphlib

/* end of file */
