/***************************************************************************
                          Dot2Gml.h  -  description
                             -------------------
    begin                : Sat Jul 28 2001
    copyright            : (C) 2001 by Petra Gleiss
    email                : petra@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SMI2GML_H
#define SMI2GML_H

#include "graph.h"

#include <fstream>
#include <string>
#include <vector>

namespace graphlib {

/**
  *@internal
  */

class Smi2Gml
{
	public:
  	//------------------------------------------------------ Con-/Destructors
    /**
      * Generates an NULL-pointer ifstream
      */
    Smi2Gml() {in = NULL; structure=""; nb_cyc = 0;}

    /**
      * Closes ifstream and deletes it
      */
		~Smi2Gml();

		/**
		  * Initialize a new ifstream binding on the file <code>fname</code>
		  *
		  * @param <code>fname</code> name of logfile
		  */
		void init(string fname);
		void init_smi(string smi);
		
  	//------------------------------------------------------ Methods
		void smi2gml(Graph&);
		int addH(Graph&);
	
	private:
  	//------------------------------------------------------ ofstrem
		ifstream *in;
		
		/// dot-bracket string
		string structure;

		unsigned nb_cyc;

  	//------------------------------------------------------ ofstrem
    // reads file -> structure
    void readStructure();
    // makes from structure -> graph
    void makeGraph(Graph&);
    // gets ring closures from smiles
    void getCycle(Graph&, int, string&, int);

}; // class Dot2Gml

} // namespace graphlib
#endif // DOT2GML_H

/* end of file */
