/* $Id: trace.cpp,v 1.1.1.1 2005/01/04 15:52:03 xtof Exp $ */
/***************************************************************************
                          trace.cpp  -  description
                             -------------------
    begin                : Fri Nov 26 1999
    copyright            : (C) 1999 by Juergen Gleiss
    email                : juergen@gleiss.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "trace.h"
#include <sstream>
#include <iomanip>

using namespace std;

namespace graphlib {

//---------------------------------------------------------------------------
// Con-/Destructors
//---------------------------------------------------------------------------
Trace::~Trace()
{
	if (out != NULL)
	{
		out->close();
		delete out;
  }
}

void Trace::init(string fname) throw(logic_error) {
	out = new ofstream(fname.c_str(), ios::out | ios::trunc);
	
	if (out->bad() || out->fail())
	{
		string err("Cant open log file ");
		err+=fname;
		err+=".";
		throw logic_error(err);	
	}
}



//---------------------------------------------------------------------------
// Methods
//---------------------------------------------------------------------------
string Trace::logging(string fname,int line,string exception,
                           string msg) {
	ostringstream str;

	if (exception == "trace")
	  str << "\t";
	if (exception != "")
		str << exception << ":\t";
	
	str << fname << "  " << line << "\t" << msg << endl;// << ends;	

  (*out) << (str.str());
	return msg;
}


string Trace::logging(string fname,string line,
                           string exception,string msg) {
	ostringstream str;

	if (exception == "trace")
	  str << "\t";
	if (exception != "")
		str << exception << ":\t";
	
	str << fname << "  " << line << "\t" << msg << endl;// << ends;	

  (*out) << (str.str());
	return msg;
}

} // namespace graphlib

/* end of file */
