/*  eigen.h - Teil aus CCMATH mathematics library source code.
 *
 *  Copyright (C)  2000   Daniel A. Atkinson    All rights reserved.
 *  This code may be redistributed under the terms of the GNU library
 *  public license (LGPL). ( See the lgpl.license file for details.)
 * ------------------------------------------------------------------------
 */



#ifndef EIGEN2_H
#define EIGEN2_H


namespace graphlib {

  int psinv(double *v,int n);
  int choldc(double *c, double *a, int n);
  int minv(double *a,int n);
  void vnorm(double *v,int n);
  void symm(double *a, int n);
  void minvsqrt(double *c, double *a, int n);
} // namespace graphlib
#endif // EIGEN_H

/* end of file */
